<?xml version="1.0" encoding="UTF-8"?>
<configuration scan="true" scanPeriod="3 seconds">
    <timestamp key="byDay" datePattern="yyyy-MM-dd"/>
    <statusListener class="ch.qos.logback.core.status.OnConsoleStatusListener"/>
    <appender name="STDOUT" class="ch.qos.logback.core.ConsoleAppender">
        <encoder>
            <pattern>
                %d{"HH:mm:ss.SSS"} [%thread] %-5level %logger{36} - %msg%n
            </pattern>
        </encoder>
    </appender>
    <appender name="FILE" class="ch.qos.logback.core.rolling.RollingFileAppender">
        <File>logs/mailingserver.log</File>
        <rollingPolicy class="ch.qos.logback.core.rolling.TimeBasedRollingPolicy">
            <FileNamePattern> logs/mailingserver.%d{"yyyy-MM-dd"}.log.zip </FileNamePattern>
            <maxHistory>60</maxHistory>
        </rollingPolicy>
        <encoder class="ch.qos.logback.classic.encoder.PatternLayoutEncoder">
            <Pattern>
                %d{"yyyy-MM-dd HH:mm:ss,SSS"} [%thread] %-5level %logger{32} - %msg%n
            </Pattern>
        </encoder>
    </appender>
    <appender name="mailingserver" class="ch.qos.logback.core.rolling.RollingFileAppender">
        <File>logs/mailingserver.csv</File>
        <rollingPolicy class="ch.qos.logback.core.rolling.TimeBasedRollingPolicy">
            <FileNamePattern>logs/backup/mailingserver%d{"yyyy-MM-dd"}.csv.zip</FileNamePattern>
        </rollingPolicy>
        <encoder class="ch.qos.logback.classic.encoder.PatternLayoutEncoder">
            <pattern>%d{"yyyy-MM-dd HH:mm:ss,SSS"};%msg%n</pattern>
        </encoder>
    </appender>

    <appender name="CUSTOM_ERROR" class="ch.qos.logback.core.rolling.RollingFileAppender">
        <File>logs/custom-error.csv</File>
        <rollingPolicy class="ch.qos.logback.core.rolling.TimeBasedRollingPolicy">
            <FileNamePattern>logs/backup/custom-error%d{"yyyy-MM-dd"}.csv.zip</FileNamePattern>
        </rollingPolicy>
        <encoder class="ch.qos.logback.core.encoder.LayoutWrappingEncoder">
            <layout class="com.nivekaa.mailingserver.handler.LogHeaderCsvLayout">
                <header>Date;Status;Message;Sub-Errors;Traces</header>
                <pattern>%d{"yyyy-MM-dd HH:mm:ss,SSS"};%msg%n</pattern>
            </layout>
        </encoder>
    </appender>

    <appender name="LOG-OPERATIONS" class="ch.qos.logback.core.rolling.RollingFileAppender">
        <File>logs/log-operations.csv</File>
        <rollingPolicy class="ch.qos.logback.core.rolling.TimeBasedRollingPolicy">
            <FileNamePattern>logs/backup/log-operations%d{"yyyy-MM-dd"}.csv.zip</FileNamePattern>
        </rollingPolicy>
        <encoder class="ch.qos.logback.core.encoder.LayoutWrappingEncoder">
            <layout class="com.nivekaa.mailingserver.handler.LogForOptsHeaderCsvLayout">
                <header>Date;Method;Status;data</header>
                <pattern>%d{"yyyy-MM-dd HH:mm:ss,SSS"};%msg%n</pattern>
            </layout>
        </encoder>
    </appender>

    <appender name="mailingserver-async" class="ch.qos.logback.classic.AsyncAppender">
        <appender-ref ref="mailingserver"/>
    </appender>

    <appender name="custom-error-async" class="ch.qos.logback.classic.AsyncAppender">
        <appender-ref ref="CUSTOM_ERROR"/>
    </appender>

    <appender name="log-operations-async" class="ch.qos.logback.classic.AsyncAppender">
        <appender-ref ref="LOG-OPERATIONS"/>
    </appender>
    <root level="DEBUG">
        <appender-ref ref="STDOUT"/>
        <appender-ref ref="FILE"/>
    </root>
    <logger name="org.springframework" level="ERROR"/>
    <logger name="org.apache.http" level="ERROR" additivity="false"/>
    <logger name="org.hibernate" level="ERROR" additivity="false"/>
    <logger name="com.netflix" level="ERROR" additivity="false"/>
    <logger name="org.springframework.beans.factory" level="ERROR" additivity="false"/>
    <logger name="mailingserver" level="INFO" additivity="false">
        <appender-ref ref="mailingserver-async"/>
    </logger>
    <logger name="CUSTOM_ERROR" level="INFO" additivity="false">
        <appender-ref ref="custom-error-async"/>
    </logger>
    <logger name="LOG-OPERATIONS" level="INFO" additivity="false">
        <appender-ref ref="log-operations-async"/>
    </logger>
    <!--
        <logger name="org.hibernate" level="INFO" additivity="false"/>
        <logger name="org.springframework" level="INFO" additivity="false"/>
        <logger name="com.zaxxer.hikari" level="INFO" additivity="false" />
        <logger name="org.apache.commons.beanutils.converters" level="INFO" additivity="false"/>
        <logger name="io.netty" level="INFO" additivity="false"/>
        <logger name="reactor.netty" level="INFO" additivity="false"/>
        <logger name="org.synchronoss" level="INFO" additivity="false"/>
    -->
</configuration>